#!/bin/bash
#
# Last update: 2023.8.14

# NAS主機IP與帳號
NAS_Server="xxx.xxx.xxx.xxx"
LoginID="xxxxx"

# 控制異機備份什麼時候執行
day_1="yes"       # 星期一是否同步日備份至day_135目錄，取消請改成no
day_2="yes"       # 星期二是否同步日備份至day_246目錄，取消請改成no
day_3="yes"       # 星期三是否同步日備份至day_135目錄，取消請改成no
day_4="yes"       # 星期四是否同步日備份至day_246目錄，取消請改成no
day_5="yes"       # 星期五是否同步日備份至day_135目錄，取消請改成no
day_6="yes"       # 星期六是否同步日備份至day_246目錄，取消請改成no
daily="no"        # 星期一至星期六都同步日備份至daily目錄，請改成yes，並將以上六個變數改成no
weekly_daily="no" # 星期日同步日備份至daily目錄，請改成yes
weekly="yes"      # 星期日是否同步週備份至weekly目錄，取消請改成no
monthly="yes"     # 每月1號是否同步月備份至monthly目錄，取消請改成no

# 判斷日期變數
day=`date +%d`
week=`date +%w`

# 超過14天備份log自動刪除
logpath="/usr/local/cpanel/logs/cpbackup/"
log=`date +%Y%m%d`
DATE_14_AGO=`date --date='14 days ago' +"%Y%m%d"`
/bin/rm -f $logpath/$DATE_14_AGO.remote_backup.log 2> /dev/null

# RemoteBackup Function

RemoteBackup(){

Directory=$1

for account in `whmapi1 get_disk_usage | grep user: | awk '{print $2}'`
do

/usr/local/cpanel/bin/pkgacct --incremental --skippublichtml $account /backup &>> $logpath/$log.remote_backup.log

# 無加上 --del 主要是避免異機帳號備份內 homedir/public_html 被刪除，後續又要rsync一次，浪費時間
/usr/bin/rsync -rvlHpDtPz --ignore-errors \
--password-file=/root/rsyncd.secrets --exclude-from=/root/exclude_list.txt \
/backup/cpmove-"${account}"/ $LoginID@$NAS_Server::$LoginID/$Directory/$account/ &>> $logpath/$log.remote_backup.log

/bin/rm -rf /backup/cpmove-"${account}"

/usr/bin/rsync -rvlHpDtPz --del --ignore-errors \
--password-file=/root/rsyncd.secrets --exclude-from=/root/exclude_list.txt \
/home/$account/public_html/ $LoginID@$NAS_Server::$LoginID/$Directory/$account/homedir/public_html/ &>> $logpath/$log.remote_backup.log

done

}

# 根據日期執行對應指令，將備份同步至正確目錄 ( 請依照客戶要求，進行適當修改 )

if [ $day == 01 ]; then

   if [ $monthly == yes ]; then

      RemoteBackup monthly

   fi

elif [ $daily == yes ] && [ ! $week == 0 ]; then

     RemoteBackup daily

elif [ $week == 1 ] || [ $week == 3 ] || [ $week == 5 ]; then

     if [ $day_1 == yes ] || [ $day_3 == yes ] || [ $day_5 == yes ]; then

	RemoteBackup day_135

     fi

elif [ $week == 2 ] || [ $week == 4 ] || [ $week == 6 ]; then

     if [ $day_2 == yes ] || [ $day_4 == yes ] || [ $day_6 == yes ]; then

	RemoteBackup day_246

     fi

elif [ $week == 0 ] && [ $weekly_daily == yes ]; then

     RemoteBackup daily

elif [ $week == 0 ] && [ $weekly_daily == no ]; then

   if [ $weekly == yes ]; then

      RemoteBackup weekly

   fi

fi
